<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- plugin-metadata.qdoc -->
  <title>Plugin Meta Data | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >Plugin Meta Data</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level2"><a href="#main-keys">Main Keys</a></li>
<li class="level2"><a href="#plugin-describing-keys">Plugin-describing Keys</a></li>
<li class="level2"><a href="#dependencies">Dependencies</a></li>
<li class="level2"><a href="#command-line-arguments">Command Line Arguments</a></li>
<li class="level2"><a href="#example-test-op-op-json">Example <code>Test.json</code></a></li>
<li class="level2"><a href="#a-note-on-plugin-versions">A Note on Plugin Versions</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Plugin Meta Data</h1>
<span class="subtitle"></span>
<!-- $$$plugin-meta-data.html-description -->
<div class="descr"> <a name="details"></a>
<p>The meta data file of a plugin is a JSON file that contains all information that is necessary for loading the plugin's library, determining whether plugins are to be loaded and in which order (depending on e.g&#x2e; dependencies). In addition, it contains textual descriptions of who created the plugin, what it is for, and where to find more information about it. The file must be located in one of the include search paths when compiling the plugin, and must have the <code>.json</code> extension. The JSON file is compiled into the plugin as meta data, which then is read by Qt Creator when loading plugins.</p>
<a name="main-keys"></a>
<h3 id="main-keys">Main Keys</h3>
<p>The main keys that are used to identify your your plugin and define default loading behavior, consist of the mandatory keys <code>Name</code> and <code>Version</code>, and the optional keys <code>CompatVersion</code>, <code>Experimental</code>, <code>DisabledByDefault</code>, <code>Required</code> and <code>Platform</code>.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Key</th><th >Value Type</th><th >Meaning</th></tr></thead>
<tr valign="top" class="odd"><td >Name</td><td >String</td><td >This is used as an identifier for the plugin and can e.g&#x2e; be referenced in other plugin's dependencies.</td></tr>
<tr valign="top" class="even"><td >Version</td><td >String</td><td >Version string in the form <code>x.y&#x2e;z_n</code>, used for identifying the plugin. Also see <a href="plugin-meta-data.html#a-note-on-plugin-versions">A Note on Plugin Versions</a>.</td></tr>
<tr valign="top" class="odd"><td >CompatVersion</td><td >String</td><td >Optional. If not given, it is implicitly set to the same value as <code>Version</code>. The compatibility version states which version of this plugin the current version is binary backward compatible with and is used to resolve dependencies on this plugin. I.e&#x2e; a <code>Version</code> of <code>2.1&#x2e;1</code> and a <code>CompatVersion</code> of <code>2.0&#x2e;0</code> means that this version <code>2.1&#x2e;1</code> of the plugin is binary backward compatible with all versions of the plugin down to <code>2.0&#x2e;0</code> (inclusive).</td></tr>
<tr valign="top" class="even"><td >Experimental</td><td >Boolean</td><td >Optional. Defaults to <code>false</code>. Experimental plugins are not loaded by default but must be explicitly enabled by the user. This attribute should be enabled for new plugins which have the potential to negatively affect the user experience.</td></tr>
<tr valign="top" class="odd"><td >DisabledByDefault</td><td >Boolean</td><td >Optional. Defaults to <code>false</code>. If set, the respective plugin is not loaded by default but must be explicitly enabled by the user. This should be done for plugins which are not expected to be used by so many people as to justify the additional resource consumption.</td></tr>
<tr valign="top" class="even"><td >HiddenByDefault</td><td >Boolean</td><td >Optional. Defaults to <code>false</code>. If set, the plugin is not shown in the default view in the <b>About Plugins..&#x2e;</b> dialog, but only if the user requests seeing all plugins. It is still shown with the <code>-version</code> command line option.</td></tr>
<tr valign="top" class="odd"><td >Required</td><td >Boolean</td><td >Optional. Defaults to <code>false</code>. Is used as a hint for the <b>About Plugins..&#x2e;</b> dialog, that the user may not manually disable this plugin. Only used for the Core plugin.</td></tr>
<tr valign="top" class="even"><td >Platform</td><td >String</td><td >Optional. A regular expression that matches the names of the platforms the plugin works on. Omitting the tag implies that the plugin is loaded on all platforms.</td></tr>
</table></div>
<a name="plugin-describing-keys"></a>
<h3 id="plugin-describing-keys">Plugin-describing Keys</h3>
<p>These are solely used for more detailed (user centric) description of the plugin. All of these are optional.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Key</th><th >Value Type</th><th >Meaning</th></tr></thead>
<tr valign="top" class="odd"><td >Category</td><td >String</td><td >Defaults to <code>Utilities</code>. Is used to put related plugins under the same tree node in the plugin overview <b>About Plugins..&#x2e;</b>.</td></tr>
<tr valign="top" class="even"><td >Vendor</td><td >String</td><td >String that describes the plugin creator/vendor, like <code>MyCompany</code>.</td></tr>
<tr valign="top" class="odd"><td >Copyright</td><td >String</td><td >A short copyright notice, like <code>(C) 2016 MyCompany</code>.</td></tr>
<tr valign="top" class="even"><td >License</td><td >String or array of strings</td><td >Possibly multi-line license information about the plugin. Should still be kept relatively short, since the UI is not designed for long texts.</td></tr>
<tr valign="top" class="odd"><td >Description</td><td >String or array of strings</td><td >Possibly multi-line description of what the plugin is supposed to provide. Should still be kept relatively short, since the UI is not designed for long texts.</td></tr>
<tr valign="top" class="even"><td >Url</td><td >String</td><td >Link to further information about the plugin, like <code>http://www.mycompany-online.com/products/greatplugin</code>.</td></tr>
</table></div>
<a name="dependencies"></a>
<h3 id="dependencies">Dependencies</h3>
<p>A plugin can have dependencies on other plugins. These are specified in the plugin meta data, to ensure that these other plugins are loaded before this plugin.</p>
<p>Dependencies are declared with the key <code>Dependency</code>, which contains an array of JSON objects with required keys <code>Name</code> and <code>Version</code>, and optional key <code>Type</code>.</p>
<p>The following formulas illustrate how the dependency information is matched. In the formulas the name of the required plugin (as defined in the <code>Name</code> of the dependency object) is denoted as <code>DependencyName</code> and the required version of the plugin is denoted as <code>DependencyVersion</code>. A plugin with given <code>Name</code>, <code>Version</code> and <code>CompatVersion</code> as defined in the plugin meta data matches the dependency if</p>
<ul>
<li>its <code>Name</code> matches <code>DependencyName</code>, and</li>
<li><code>CompatVersion &lt;= DependencyVersion &lt;= Version</code>.</li>
</ul>
<p>For example a dependency</p>
<pre class="cpp">

  {
      <span class="string">&quot;Name&quot;</span> : <span class="string">&quot;SomeOtherPlugin&quot;</span><span class="operator">,</span>
      <span class="string">&quot;Version&quot;</span> : <span class="string">&quot;2.3.0_2&quot;</span>
  }

</pre>
<p>would be matched by a plugin with</p>
<pre class="cpp">

  {
      <span class="string">&quot;Name&quot;</span> : <span class="string">&quot;SomeOtherPlugin&quot;</span><span class="operator">,</span>
      <span class="string">&quot;Version&quot;</span> : <span class="string">&quot;3.1.0&quot;</span><span class="operator">,</span>
      <span class="string">&quot;CompatVersion&quot;</span> : <span class="string">&quot;2.2.0&quot;</span><span class="operator">,</span>
      <span class="operator">.</span><span class="operator">.</span><span class="operator">.</span>
  }

</pre>
<p>since the name matches, and the version <code>2.3&#x2e;0_2</code> given in the dependency tag lies in the range of <code>2.2&#x2e;0</code> and <code>3.1&#x2e;0</code>.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Key</th><th >Value Type</th><th >Meaning</th></tr></thead>
<tr valign="top" class="odd"><td >Dependencies</td><td >Array of dependency objects</td><td >Describes the dependencies on other plugins.</td></tr>
</table></div>
<p>A dependency object is a JSON object with the following keys:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Key</th><th >Value Type</th><th >Meaning</th></tr></thead>
<tr valign="top" class="odd"><td >Name</td><td >String</td><td >The name of the plugin, on which this plugin relies.</td></tr>
<tr valign="top" class="even"><td >Version</td><td >String</td><td >The version to which the plugin must be compatible to fill the dependency, in the form <code>x.y&#x2e;z_n</code>. Can be empty if the version does not matter.</td></tr>
<tr valign="top" class="odd"><td >Type</td><td >String</td><td >Optional. Value <code>Required</code>, <code>Optional</code>, or <code>Test</code>. Defines if the dependency is a hard requirement, optional, or required for running the plugin's tests. Defaults to <code>Required</code>.</td></tr>
</table></div>
<a name="optional-dependencies"></a>
<h4 id="optional-dependencies">Optional Dependencies</h4>
<p>A plugin can specify that a dependency on another plugin is optional, by adding <code>&quot;Type&quot; : &quot;Optional&quot;</code> to the dependency object:</p>
<ul>
<li>If the dependency can be resolved, the plugin and its dependency are loaded and initialized as for <code>Required</code> dependencies.</li>
<li>If the dependency cannot be resolved, the plugin is loaded and initialized as if the dependency was not declared at all.</li>
</ul>
<p>The plugin is not informed about the existence of optional dependencies in any way. Since the dependency might be loaded or not, the plugin may also not link against the dependency. A common way to access objects from optional dependencies is to get the object from the <a href="pluginmanager.html">global object pool</a> via ExtensionSystem::PluginManager::getObjectByName() and use <a href="http://doc.qt.io/qt-5/qmetaobject.html">QMetaObject</a> functions to call functions on it.</p>
<a name="test-dependencies"></a>
<h4 id="test-dependencies">Test Dependencies</h4>
<p>When the user runs the application with the <code>-test</code> command line argument, only the specified plugins and their dependencies are loaded. This is done in order to speed up the execution of tests by avoiding the loading of unneeded plugins.</p>
<p>A plugin can specify additional dependencies that are required for running its tests, but not for its normal execution, by declaring dependencies with <code>&quot;Type&quot; : &quot;Test&quot;</code>. Test dependencies are force loaded, and do not affect load order.</p>
<p>This type of dependency is not transitive.</p>
<a name="command-line-arguments"></a>
<h3 id="command-line-arguments">Command Line Arguments</h3>
<p>Plugins can register command line arguments that the user can give when starting the application. These command line arguments are shown with a one-line description when the user runs the application with the <code>-help</code> command line argument, and the plugin manager does its command line parsing and sanity checks based on that information. If the plugin manager finds matching command line arguments for a plugin, it passes them on to the plugin's initialize() function.</p>
<p>Command line arguments are defined through the key <code>Arguments</code>, which contains an array of argument objects. Each individual argument object has the required key <code>Name</code>, and optional keys <code>Parameter</code> and <code>Description</code>.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Key</th><th >Value Type</th><th >Meaning</th></tr></thead>
<tr valign="top" class="odd"><td >Arguments</td><td >Array of argument objects</td><td >Describes the command line arguments that the plugin wants to handle.</td></tr>
</table></div>
<p>An argument object is a JSON object with the following keys:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Key</th><th >Value Type</th><th >Meaning</th></tr></thead>
<tr valign="top" class="odd"><td >Name</td><td >String</td><td >The command line argument itself, including the <code>-</code> prefix, e.g&#x2e; <code>-my-parameter</code>.</td></tr>
<tr valign="top" class="even"><td >Parameter</td><td >String</td><td >Optional. If this is given, the command line argument expects an additional parameter, e.g&#x2e; <code>-my-parameter somevalue</code>. The value of this attribute is used as a very short description of the parameter for the user.</td></tr>
<tr valign="top" class="odd"><td >Description</td><td >String</td><td >Optional. A (one-line) description of the argument for the command line argument help.</td></tr>
</table></div>
<a name="example-test-op-op-json"></a>
<h3 id="example-test-op-op-json">Example <code>Test.json</code></h3>
<pre class="cpp">

  {
      <span class="string">&quot;Name&quot;</span> : <span class="string">&quot;Test&quot;</span><span class="operator">,</span>
      <span class="string">&quot;Version&quot;</span> : <span class="string">&quot;1.0.1&quot;</span><span class="operator">,</span>
      <span class="string">&quot;CompatVersion&quot;</span> : <span class="string">&quot;1.0.0&quot;</span><span class="operator">,</span>
      <span class="string">&quot;Vendor&quot;</span> : <span class="string">&quot;My Company&quot;</span><span class="operator">,</span>
      <span class="string">&quot;Copyright&quot;</span> : <span class="string">&quot;(C) 2016 MyCompany&quot;</span><span class="operator">,</span>
      <span class="string">&quot;License&quot;</span> : <span class="operator">[</span>
          <span class="string">&quot;This is a default license bla&quot;</span><span class="operator">,</span>
          <span class="string">&quot;blubbblubb&quot;</span><span class="operator">,</span>
          <span class="string">&quot;end of terms&quot;</span>
      <span class="operator">]</span><span class="operator">,</span>
      <span class="string">&quot;Category&quot;</span> : <span class="string">&quot;My Company Additions&quot;</span><span class="operator">,</span>
      <span class="string">&quot;Description&quot;</span> : <span class="operator">[</span>
          <span class="string">&quot;This plugin is just a test.&quot;</span><span class="operator">,</span>
          <span class="string">&quot;It demonstrates the great use of the plugin meta data.&quot;</span>
      <span class="operator">]</span><span class="operator">,</span>
      <span class="string">&quot;Url&quot;</span> : <span class="string">&quot;http://www.mycompany-online.com/products/greatplugin&quot;</span><span class="operator">,</span>
      <span class="string">&quot;Arguments&quot;</span> : <span class="operator">[</span>
          {
              <span class="string">&quot;Name&quot;</span> : <span class="string">&quot;-variant&quot;</span><span class="operator">,</span>
              <span class="string">&quot;Parameter&quot;</span> : <span class="string">&quot;fancy|boring&quot;</span><span class="operator">,</span>
              <span class="string">&quot;Description&quot;</span> : <span class="string">&quot;Brings up the fancy or boring user interface&quot;</span>
          }
      <span class="operator">]</span><span class="operator">,</span>
      <span class="string">&quot;Dependencies&quot;</span> : <span class="operator">[</span>
          { <span class="string">&quot;Name&quot;</span> : <span class="string">&quot;SomeOtherPlugin&quot;</span><span class="operator">,</span> <span class="string">&quot;Version&quot;</span> : <span class="string">&quot;2.3.0_2&quot;</span> }<span class="operator">,</span>
          { <span class="string">&quot;Name&quot;</span> : <span class="string">&quot;EvenOther&quot;</span><span class="operator">,</span> <span class="string">&quot;Version&quot;</span> : <span class="string">&quot;1.0.0&quot;</span> }
      <span class="operator">]</span>
  }

</pre>
<a name="a-note-on-plugin-versions"></a>
<h3 id="a-note-on-plugin-versions">A Note on Plugin Versions</h3>
<p>Plugin versions are in the form <code>x.y&#x2e;z_n</code> where, <code>x</code>, <code>y</code>, <code>z</code> and <code>n</code> are non-negative integer numbers. You don't have to specify the version in this full form - any left-out part will implicitly be set to zero. So, <code>2.10_2</code> is equal to <code>2.10.0_2</code>, and <code>1</code> is the same as <code>1.0&#x2e;0_0</code>.</p>
</div>
<!-- @@@plugin-meta-data.html -->
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
